unit BootSector;

interface
 uses Dialogs,SysUtils;

Type TBiosParameterblock = packed Record
                  {DEC HEX}
                  { 11  0B}  BytesPerSector:Word;
                  { 13  0D}  SectorsPerCluster:Byte;
                  { 14  0E}  Reserved:Word;
                  { 16  10}  Fats:Byte;
                  { 17  11}  RootEntries:Word;
                  { 19  13}  SmallSectors:Word;
                  { 21  15}  MediaType:Byte;
                  { 22  16}  SectorsPerFat:Word;
                  { 24  18}  SectorsPerTrack:Word;
                  { 26  1A}  Heads:Word;
                  { 28  1C}  HiddenSectors:Integer;
                  { 32  20}  LargeSectors:Integer;
                           end;

Type TExtendedBiosParameterBlock = packed Record
                          {DEC HEX}
                          {036  24}  PhysicalDiskNumber:Byte;
                          {037  25}  CurrentHead:Byte;
                          {038  26}  Signature:Byte;
                          {039  27}  SerialNumber:array[0..3] of byte;
                          {043  2B}  VolumeLabel:array[0..10] of byte;
                          {054  36}  SystemFATID:array[0..7] of byte;
                                   end;

Type TBootStrap = packed array[0..447] of byte;

Type TBootSector = packed Record    //packed voor alle MSDOS records !!!
         {DEC HEX}
         {000  00}   Jump:Array[0..2] of byte;
         {003  03}   OEM:Array[0..7] of char;
         {011  0B}   BiosParameterBlock:TBiosParameterblock;
         {036  24}   ExtendedBiosParameterBlock:TExtendedBiosParameterBlock;
         {062  3E}   BootStrap:TBootStrap;
         {510 1FE}   EndOfSector:Array[0..1] of byte;  {Altijd '55 AA' HEX}
                   end;


Const EL_BiosParameterblock :TBiosParameterblock =
      (
       BytesPerSector:512;
       SectorsPerCluster:1;
       Reserved:1;
       Fats:2;
       RootEntries:224;
       SmallSectors:2880;
       MediaType:240;
       SectorsPerFat:9;
       SectorsPerTrack:18;
       Heads:2;
       HiddenSectors:0;
       LargeSectors:0;
      );


function MsgDlg(const Msg: string):Integer;overload;
function MsgDlg(const I:Integer):Integer;overload;
function MsgDlg(const I:Int64):Integer;overload;

implementation

function MsgDlg(const Msg: string):Integer;overload;
begin
  Result := MessageDlgPosHelp(Msg, MtInformation,[mbok],0, -1, -1, '');
end;

function MsgDlg(const I:Integer):Integer;overload;
begin
  Result := MessageDlgPosHelp(IntToStr(I), MtInformation,[mbok],0, -1, -1, '');
end;

function MsgDlg(const I:Int64):Integer;overload;
begin
  Result := MessageDlgPosHelp(IntToStr(I), MtInformation,[mbok],0, -1, -1, '');
end;

end.
