unit NT_Floppy;

interface
uses windows,Dialogs,SysUtils,Floppy32,BootSector;

Type T_NT_Floppy = class(TPhysicalFloppy)
                   Private
                   Protected
                     Procedure CheckVersion;override;

                   Public
                     Function ReadFloppySector(Var Data;Drive,Side,Track,Sector:byte):DWORD;override;
                     Function ReadFloppyTrack(Var Data;Drive,Side,Track,SectorCount:byte):DWORD;override;
                     Function ReadFloppy(Var Data;Drive:Byte):DWORD;override;
                     Function WriteFloppySector(Var Data;Drive,Side,Track,Sector:byte):DWORD;override;
                     Function WriteFloppyTrack(Var Data;Drive,Side,Track,SectorCount:byte):DWORD;override;
                     Function WriteFloppy(Var Data;Drive:Byte):DWORD;override;
                     Function NewDisk(Drive:Byte):DWORD;override;
                     Function GetDiskGeometry(Var Geometry:T_DISK_GEOMETRY;Drive:Byte):DWORD;override;
                     Function DiskSize(Drive:Byte):DWORD;override;
                     Function SeekLogicalSector(Drive:Byte;Sector:Dword):DWORD;override;
                     Function ReadNextFloppyTrack(Var Data):DWORD;override;
                     Function ReadNextFloppySector(Var Data):DWORD;override;
                     Function WriteNextFloppyTrack(Var Data):DWORD;override;
                     Function WriteNextFloppySector(Var Data):DWORD;override;
                     Function LockDrive(Drive:Byte):DWORD;override;
                     Function UnLockDrive(Drive:Byte):DWORD;override;
                     Function DismountDrive(Drive:Byte):DWORD;
                     Function FormatTracks(Drive:Byte;var FormatParameters:T_FORMAT_PARAMETERS):DWORD;override;
                   End;


Const METHOD_BUFFERED   =0;
Const METHOD_IN_DIRECT  =1;
Const METHOD_OUT_DIRECT =2;
Const METHOD_NEITHER    =3;

Const FILE_ANY_ACCESS   =0;
Const FILE_READ_ACCESS  =1;
Const FILE_WRITE_ACCESS =2;



const DISK_FUNCTION_0  = $0000;
const DISK_FUNCTION_1  = $0001;
const DISK_FUNCTION_2  = $0002;
const DISK_FUNCTION_3  = $0003;
const DISK_FUNCTION_4  = $0004;
const DISK_FUNCTION_5  = $0005;
const DISK_FUNCTION_6  = $0006;
const DISK_FUNCTION_7  = $0007;
const DISK_FUNCTION_8  = $0008;
const DISK_FUNCTION_9  = $0009;
const DISK_FUNCTION_A  = $000A;
const DISK_FUNCTION_B  = $000B;
const DISK_FUNCTION_C  = $000C;
const DISK_FUNCTION_D  = $000D;
const DISK_FUNCTION_E  = $000E;
const DISK_FUNCTION_F  = $000F;
const DISK_FUNCTION_10 = $0010;

const FILE_DEVICE_DISK         = 7;
const FILE_DEVICE_FILE_SYSTEM  = 9;

// ((DeviceType) << 16) | ((Access) << 14) | ((Function) << 2) | (Method) \


const IOCTL_DISK_BASE = FILE_DEVICE_DISK;
Const IOCTL_DISK_GET_GEOMETRY        =((IOCTL_DISK_BASE shl 16) or (DISK_FUNCTION_0 shl 2) or (FILE_ANY_ACCESS shl 14) or (METHOD_BUFFERED));
Const IOCTL_DISK_GET_PARTITION_INFO  =((IOCTL_DISK_BASE shl 16) or (DISK_FUNCTION_1 shl 2) or (FILE_READ_ACCESS shl 14)or (METHOD_BUFFERED));
Const IOCTL_DISK_SET_PARTITION_INFO  =((IOCTL_DISK_BASE shl 16) or (DISK_FUNCTION_2 shl 2) or ((FILE_READ_ACCESS or FILE_WRITE_ACCESS) shl 14) or (METHOD_BUFFERED));
Const IOCTL_DISK_GET_DRIVE_LAYOUT    =((IOCTL_DISK_BASE shl 16) or (DISK_FUNCTION_3 shl 2) or (FILE_READ_ACCESS shl 14)or (METHOD_BUFFERED));
Const IOCTL_DISK_SET_DRIVE_LAYOUT    =((IOCTL_DISK_BASE shl 16) or (DISK_FUNCTION_4 shl 2) or ((FILE_READ_ACCESS or FILE_WRITE_ACCESS) shl 14) or (METHOD_BUFFERED));
Const IOCTL_DISK_VERIFY              =((IOCTL_DISK_BASE shl 16) or (DISK_FUNCTION_5 shl 2) or (FILE_ANY_ACCESS shl 14) or (METHOD_BUFFERED));
Const IOCTL_DISK_FORMAT_TRACKS       =((IOCTL_DISK_BASE shl 16) or (DISK_FUNCTION_6 shl 2) or ((FILE_READ_ACCESS or FILE_WRITE_ACCESS) shl 14) or (METHOD_BUFFERED));
Const IOCTL_DISK_REASSIGN_BLOCKS     =((IOCTL_DISK_BASE shl 16) or (DISK_FUNCTION_7 shl 2) or ((FILE_READ_ACCESS or FILE_WRITE_ACCESS) shl 14) or (METHOD_BUFFERED));
Const IOCTL_DISK_PERFORMANCE         =((IOCTL_DISK_BASE shl 16) or (DISK_FUNCTION_8 shl 2) or (FILE_ANY_ACCESS shl 14) or (METHOD_BUFFERED));
Const IOCTL_DISK_IS_WRITABLE         =((IOCTL_DISK_BASE shl 16) or (DISK_FUNCTION_9 shl 2) or (FILE_ANY_ACCESS shl 14) or (METHOD_BUFFERED));
Const IOCTL_DISK_LOGGING             =((IOCTL_DISK_BASE shl 16) or (DISK_FUNCTION_A shl 2) or (FILE_ANY_ACCESS shl 14) or (METHOD_BUFFERED));
Const IOCTL_DISK_FORMAT_TRACKS_EX    =((IOCTL_DISK_BASE shl 16) or (DISK_FUNCTION_B shl 2) or ((FILE_READ_ACCESS or FILE_WRITE_ACCESS) shl 14) or (METHOD_BUFFERED));
Const IOCTL_DISK_HISTOGRAM_STRUCTURE =((IOCTL_DISK_BASE shl 16) or (DISK_FUNCTION_C shl 2) or (FILE_ANY_ACCESS shl 14) or (METHOD_BUFFERED));
Const IOCTL_DISK_HISTOGRAM_DATA      =((IOCTL_DISK_BASE shl 16) or (DISK_FUNCTION_D shl 2) or (FILE_ANY_ACCESS shl 14) or (METHOD_BUFFERED));
Const IOCTL_DISK_HISTOGRAM_RESET     =((IOCTL_DISK_BASE shl 16) or (DISK_FUNCTION_E shl 2) or (FILE_ANY_ACCESS shl 14) or (METHOD_BUFFERED));
Const IOCTL_DISK_REQUEST_STRUCTURE   =((IOCTL_DISK_BASE shl 16) or (DISK_FUNCTION_F shl 2) or (FILE_ANY_ACCESS shl 14) or (METHOD_BUFFERED));
Const IOCTL_DISK_REQUEST_DATA        =((IOCTL_DISK_BASE shl 16) or (DISK_FUNCTION_10 shl 2) or (FILE_ANY_ACCESS shl 14) or (METHOD_BUFFERED));


Const FSCTL_LOCK_VOLUME              =((FILE_DEVICE_FILE_SYSTEM shl 16) or (6 shl 2) or (FILE_ANY_ACCESS shl 14) or (METHOD_BUFFERED));
Const FSCTL_UNLOCK_VOLUME            =((FILE_DEVICE_FILE_SYSTEM shl 16) or (7 shl 2) or (FILE_ANY_ACCESS shl 14) or (METHOD_BUFFERED));
Const FSCTL_DISMOUNT_VOLUME          =((FILE_DEVICE_FILE_SYSTEM shl 16) or (8 shl 2) or (FILE_ANY_ACCESS shl 14) or (METHOD_BUFFERED));






implementation

type
  E_NT_Floppy_Error = class(Exception);

{ T_NT_Floppy }


Procedure T_NT_Floppy.CheckVersion;
var Os:TOSVersionInfo;
begin
   Os.dwOSVersionInfoSize:=SizeOf(TOSVersionInfo);
   if GetVersionEx(Os) then
   Begin
     Case Os.dwPlatformId of
     VER_PLATFORM_WIN32s:raise E_NT_Floppy_Error.Create('E_NT_Floppy_Error Win32s is not supported');
     VER_PLATFORM_WIN32_WINDOWS:raise E_NT_Floppy_Error.Create('E_NT_Floppy_Error WIN 95/98 is not supported');
     End;
   End else raise E_NT_Floppy_Error.Create('E_NT_Floppy_Error GetVersionEx failed');
end;

function T_NT_Floppy.DiskSize(Drive:Byte): DWORD;
begin
  if (Not FDiskOpen) or (Drive <> FDrive) then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
  with FDiskGeometry do
  Begin
    Result:=Cylinders.lowpart*TracksPerCylinder*SectorsPerTrack*BytesPerSector;
  End;
end;

function T_NT_Floppy.GetDiskGeometry(var Geometry:T_DISK_GEOMETRY;Drive:Byte): DWORD;
var ReturnedByteCount:DWORD;
begin
  if (Not FDiskOpen) or (Drive <> FDrive) then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
    DeviceIoControl(FDrive_Handle,IOCTL_DISK_GET_GEOMETRY,nil,0,@Geometry,Sizeof(T_DISK_GEOMETRY),ReturnedByteCount,nil);
    if Geometry.MediaType = Unknown then MsgDlg('Unknown MediaType') else
    //MsgDlg(DWORD(Geometry.MediaType));
    result:=0;
end;

function T_NT_Floppy.LockDrive(Drive: Byte): DWORD;
Var ReturnedByteCount:DWORD;
begin
  if (Not FDiskOpen) or (Drive <> FDrive) then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
  if DeviceIoControl(FDrive_Handle,FSCTL_LOCK_VOLUME,nil,0,nil,0,ReturnedByteCount,nil) then
  result:=0 else result:=GetlastError;
end;

function T_NT_Floppy.UnLockDrive(Drive: Byte): DWORD;
Var ReturnedByteCount:DWORD;
begin
  DismountDrive(Drive);
  if (Not FDiskOpen) or (Drive <> FDrive) then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
  if DeviceIoControl(FDrive_Handle,FSCTL_UNLOCK_VOLUME,nil,0,nil,0,ReturnedByteCount,nil) then
  result:=0 else result:=GetlastError;
end;


function T_NT_Floppy.NewDisk(Drive: Byte): DWORD;
Const NtDrive:String ='\\.\X:';
begin
  if FDiskOpen then
  Begin
    if FDrive_Handle <> INVALID_HANDLE_VALUE then CloseHandle(FDrive_Handle);
    FDiskOpen:=False;
  End;
  FDrive:=Drive;
  NtDrive[5]:=Char(FDrive+65);
  FDrive_Handle:=CreateFile(Pchar(NtDrive),
                            GENERIC_READ or GENERIC_WRITE,
                            FILE_SHARE_READ or FILE_SHARE_WRITE,
                            nil,OPEN_EXISTING,0,0);
  if  FDrive_Handle = INVALID_HANDLE_VALUE then
  Begin
    CloseHandle(FDrive_Handle);
    result:=1;
    exit;
  end;
  SetFilePointer(FDrive_Handle,0,nil,FILE_BEGIN);
  FDiskOpen:=True;
  Result:=0;
  GetDiskGeometry(FDiskGeometry,Drive);
End;

function T_NT_Floppy.ReadFloppy(var Data; Drive: Byte): DWORD;
Var BytesRead,BytesToRead:DWORD;
Begin
  if (Not FDiskOpen) or (Drive <> FDrive) then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
  with FDiskGeometry do
  Begin
    BytesToRead:=Cylinders.lowpart*TracksPerCylinder*SectorsPerTrack*BytesPerSector;
  End;
  if not ReadFile(FDrive_Handle,Data,BytesToRead,BytesRead,nil) then
  Begin
    result:=3;
    Exit;
  End;
  Result:=0;
End;


function T_NT_Floppy.ReadFloppySector(var Data; Drive, Side, Track,
  Sector: byte): DWORD;
  Var BytesRead,OffsetRead:DWORD;

Begin
  if (Not FDiskOpen) or (Drive <> FDrive) then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
  with FDiskGeometry do
  Begin
    OffsetRead:=((Track*TracksPerCylinder*SectorsPerTrack)+
                (Side*SectorsPerTrack)+
                (Sector-1))*BytesPerSector;
  End;
  SetFilePointer(FDrive_Handle,OffsetRead,nil,FILE_BEGIN);
  if not ReadFile(FDrive_Handle,Data,FDiskGeometry.BytesPerSector,BytesRead,nil) then
  Begin
    result:=2;
    Exit;
  End;
  Result:=0;
End;

function T_NT_Floppy.ReadFloppyTrack(var Data; Drive, Side, Track,
  SectorCount: byte): DWORD;
  Var BytesRead,OffsetRead:DWORD;

Begin
  if (Not FDiskOpen) or (Drive <> FDrive) then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
  with FDiskGeometry do
  Begin
    OffsetRead:=((Track*TracksPerCylinder*SectorsPerTrack)+
                (Side*SectorsPerTrack))*BytesPerSector;
  End;
  SetFilePointer(FDrive_Handle,OffsetRead,nil,FILE_BEGIN);
  if not ReadFile(FDrive_Handle,Data,FDiskGeometry.BytesPerSector*SectorCount,BytesRead,nil) then
  Begin
    result:=3;
    Exit;
  End;
  Result:=0;
End;

function T_NT_Floppy.ReadNextFloppySector(var Data): DWORD;
Var BytesRead:DWORD;
begin
  if (Not FDiskOpen) then
  Begin
    result:=1;
    exit;
  end;


  if not ReadFile(FDrive_Handle,Data,(FDiskGeometry.BytesPerSector),BytesRead,nil) then
  Begin


    result:=GetLastError;
    Exit;
  End;
  Result:=0;
end;

function T_NT_Floppy.ReadNextFloppyTrack(var Data): DWORD;
Var BytesRead,P1,P2:DWORD;
begin
  if (Not FDiskOpen) then
  Begin
    result:=1;
    exit;
  end;
  P1:=SetFilePointer(FDrive_Handle,0,nil,FILE_CURRENT);
  if not ReadFile(FDrive_Handle,Data,(FDiskGeometry.BytesPerSector*FDiskGeometry.SectorsPerTrack),BytesRead,nil) then
  Begin
    result:=GetLastError;
    P2:=SetFilePointer(FDrive_Handle,0,nil,FILE_CURRENT);
    MsgDlg(IntToStr(P1)+' '+IntToStr(P2));
    Exit;
  End;
  Result:=0;
end;

function T_NT_Floppy.SeekLogicalSector(Drive: Byte; Sector: Dword): DWORD;
begin
  if (Not FDiskOpen) or (Drive <> FDrive) then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
  with FDiskGeometry do
  Begin
    if Sector >= Cylinders.lowpart*TracksPerCylinder*SectorsPerTrack then
    Begin
      result:=2;
      exit;
    end;
  End;
  SetFilePointer(FDrive_Handle,Sector*FDiskGeometry.BytesPerSector,nil,FILE_BEGIN);
  Result:=0;
end;

function T_NT_Floppy.WriteFloppy(var Data; Drive: Byte): DWORD;
Var BytesRead,BytesToRead:DWORD;
Begin
  if (Not FDiskOpen) or (Drive <> FDrive) then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
  with FDiskGeometry do
  Begin
    BytesToRead:=Cylinders.lowpart*TracksPerCylinder*SectorsPerTrack*BytesPerSector;
  End;
  if not WriteFile(FDrive_Handle,Data,BytesToRead,BytesRead,nil) then
  Begin
    result:=3;
    Exit;
  End;
  Result:=0;
End;

function T_NT_Floppy.WriteFloppySector(var Data; Drive, Side, Track,
  Sector: byte): DWORD;
  Var BytesRead,OffsetRead:DWORD;

Begin
  if (Not FDiskOpen) or (Drive <> FDrive) then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
  with FDiskGeometry do
  Begin
    OffsetRead:=((Track*TracksPerCylinder*SectorsPerTrack)+
                (Side*SectorsPerTrack)+
                (Sector-1))*BytesPerSector;
  End;
  SetFilePointer(FDrive_Handle,OffsetRead,nil,FILE_BEGIN);
  if not WriteFile(FDrive_Handle,Data,FDiskGeometry.BytesPerSector,BytesRead,nil) then
  Begin
    result:=2;
    Exit;
  End;
  Result:=0;
End;

function T_NT_Floppy.WriteFloppyTrack(var Data; Drive, Side, Track,
  SectorCount: byte): DWORD;
  Var BytesRead,OffsetRead:DWORD;

Begin
  if (Not FDiskOpen) or (Drive <> FDrive) then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
  with FDiskGeometry do
  Begin
    OffsetRead:=((Track*TracksPerCylinder*SectorsPerTrack)+
                (Side*SectorsPerTrack))*BytesPerSector;
  End;
  SetFilePointer(FDrive_Handle,OffsetRead,nil,FILE_BEGIN);
  if not WriteFile(FDrive_Handle,Data,FDiskGeometry.BytesPerSector*SectorCount,BytesRead,nil) then
  Begin
    result:=3;
    Exit;
  End;
  Result:=0;
End;

function T_NT_Floppy.WriteNextFloppySector(var Data): DWORD;
Var BytesWritten:DWORD;
begin
  if (Not FDiskOpen) then
  Begin
    result:=1;
    exit;
  end;
  if not WriteFile(FDrive_Handle,Data,(FDiskGeometry.BytesPerSector),BytesWritten,nil) then
  Begin
    result:=2;
    Exit;
  End;
  Result:=0;
end;

function T_NT_Floppy.WriteNextFloppyTrack(var Data): DWORD;
Var BytesWritten:DWORD;
begin
  if (Not FDiskOpen) then
  Begin
    result:=1;
    exit;
  end;
  if not WriteFile(FDrive_Handle,Data,(FDiskGeometry.BytesPerSector*FDiskGeometry.SectorsPerTrack),BytesWritten,nil) then
  Begin
    result:=2;
    Exit;
  End;
  Result:=0;
End;

function T_NT_Floppy.DismountDrive(Drive: Byte): DWORD;
Var ReturnedByteCount:DWORD;
begin
  if (Not FDiskOpen) or (Drive <> FDrive) then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
  if DeviceIoControl(FDrive_Handle,FSCTL_DISMOUNT_VOLUME,nil,0,nil,0,ReturnedByteCount,nil) then
  result:=0 else result:=GetlastError;
end;

function T_NT_Floppy.FormatTracks(Drive: Byte;
  var FormatParameters: T_FORMAT_PARAMETERS): DWORD;
var ReturnedByteCount:DWORD;
begin
  if (Not FDiskOpen) or (Drive <> FDrive) then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
  if DeviceIoControl(FDrive_Handle,IOCTL_DISK_FORMAT_TRACKS,@FormatParameters,Sizeof(T_FORMAT_PARAMETERS),nil,0,ReturnedByteCount,nil) then
  result:=0 else result:=GetlastError;
end;

end.



