unit int13;

interface
  uses windows,SysUtils,dialogs,Floppy32,BootSector;

type Reg_Word = record
                case Integer of
                0:(All:word);
                1:(Lo:byte;Hi:byte)
                end;

Type _DIOC_REGISTERS = record
                         reg_EBX:DWORD;
                         reg_EDX:DWORD;
                         reg_ECX:DWORD;
                         reg_EAX:DWORD;
                         reg_EDI:DWORD;
                         reg_ESI:DWORD;
                         reg_Flags:DWORD;
                        end;

Type TBoot = packed Record    //packed voor alle MSDOS records !!!
         {000} Sprong:Array[0..2] of byte;
         {003} Fabrikant:Array[0..7] of char;
         {011} BytesSector:Word;
         {013} Sectclus:Byte;
         {014} geres:word;
         {016} fats:byte;
         {017} maxdir:word;
         {019} sectoren:word;
         {021} media:byte;
         {022} sectfat:word;
         {024} sectsp:word;
         {026} koppen:word;
         {028} verborgen:word;
         {030} Weetniet:Word;
         {032} TotSec:longint;
         {036} Drive:Word;
         {038} Handtekening:byte;
         {039} Serie:longint;
         {043} Volumenaam:array[0..10] of char;
         {054} Fattype:array[0..7] of char;
               BootProgramma:array[0..449] of byte
              end;


Type TDriveParameters = Packed Record
                                 case Integer of
                                 0:(bytes:array[0..10] of byte);
                                 1:(
                                   FirstSpecifyByte:Byte;
                                   SecondSpecifyByte:Byte;
                                   DelayUntilMotorOff:Byte;
                                   BytesPerSector:Byte;
                                   SectorsPerTrack:Byte;
                                   LengthOfGap:Byte;
                                   DataLength:Byte;
                                   GapLength:Byte;
                                   FormatFiller:Byte;
                                   HeadSettleTime:Byte;
                                   MotorStartTime:Byte;
                                   );
                               End;


Type TFormatAddres = Packed Record
                            case Integer of
                            0:(bytes:array[0..3] of byte);
                            1:(
                              TrackNumber:Byte;
                              HeadNumber:Byte;
                              SectorNumber:Byte;
                              SectorSize:Byte;
                              );
                            End;


Type TFormatTrack = Packed array[1..18] of TFormatAddres;



Type T_DOSDPB = Packed Record
                         specialFunc:BYTE;
                         devType:BYTE;
                         devAttr:WORD;
                         cCyl:WORD;
                         MediaType:BYTE;

                         cbSec:WORD; //bytes per Sector
                         secPerClus:BYTE; //Sectors per Cluster
                         cSecRes:WORD;    //Res
                         cFat:BYTE;       //Number of Fats
                         cDir:WORD;       //Root entry s
                         cSec:WORD;       //Number of sectors
                         bMedia:BYTE;     //Media ID
                         SecPerFat:WORD;  //Sectors per fat

                         SecPerTrack:WORD;
                         cHead:WORD;
                         cSecHidden:DWORD;
                         cTotalSectors:DWORD;
                         reserved:array[0..5] of BYTE;
                       End;


Type T_SectorInfo = Packed Record
                             Number:Word;
                             Size:Word;
                           End;

Type T_720_DPB = Packed Record
                          DPB:T_DOSDPB;
                          SecCount:Word;
                          Sectors:Array[1..9] of T_SectorInfo;
                        end;

Type T_Par = Packed array[0..10] of byte;

Const

 VWIN32_DIOC_DOS_IOCTL = 1;     // Performs the specified MS-DOS device I/O control function (Interrupt 21h Function 4400h through 4411h)
 VWIN32_DIOC_DOS_INT25 = 2;     // Performs the Absolute Disk Read command (Interrupt 25h)
 VWIN32_DIOC_DOS_INT26 = 3;     // Performs the Absolute Disk Write command (Interrupt 25h)
 VWIN32_DIOC_DOS_INT13 = 4;     //  Performs Interrupt 13h commands
 VWIN32_DIOC_DOS_DRIVEINFO = 6; //  Performs Interrupt 21h Function 730X commands. This value is supported in Windows 95 OEM Service Release 2 and later.


VxD_Name:PChar = '\\.\vwin32';



Type TInt13Handler = Class(TPhysicalFloppy)
                      Private
                        Int13Reg:_DIOC_REGISTERS;
                        FCurrentSector:DWORD;
                        Procedure Interrupt13;
                        Procedure Interrupt21;
                        Procedure ResetDrive(Drive:Byte);
                        Function GetDriveType(Drive:Byte;var Geo:T_DISK_GEOMETRY):DWORD;
                        Procedure  Do720;

                        Function CompileBootSector(Drive:Byte;var BootGeo:T_DISK_GEOMETRY):DWORD;
                      Protected
                        Procedure CheckVersion;override;
                      Public
                        Function ReadFloppySector(Var Data;Drive,Side,Track,Sector:byte):DWORD;override;
                        Function WriteFloppySector(Var Data;Drive,Side,Track,Sector:byte):DWORD;override;
                        Function ReadFloppyTrack(Var Data;Drive,Side,Track,SectorCount:byte):DWORD;override;
                        Function WriteFloppyTrack(Var Data;Drive,Side,Track,SectorCount:byte):DWORD;override;
                        Function ReadFloppy(Var Data;Drive:Byte):DWORD;override;
                        Function WriteFloppy(Var Data;Drive:Byte):DWORD;override;
                        Function FormatFloppyTrack(Drive,Side,Track:byte):DWORD;
                        Function InitFormat(Drive:Byte):Dword;
                        Function ResetFloppydrive(Drive:Byte):DWORD;

                        Function DiskSize(Drive:Byte):DWORD;override;
                        Function NewDisk(Drive:Byte):DWORD;override;

                        Function GetDiskGeometry(Var Geometry:T_DISK_GEOMETRY;Drive:Byte):DWORD;override;
                        Function GetDiskGeometry2(Var Geometry:T_DISK_GEOMETRY;Drive:Byte):DWORD;

                        Function SeekLogicalSector(Drive:Byte;Sector:Dword):DWORD;override;

                        Function ReadNextFloppyTrack(Var Data):DWORD;override;
                        Function ReadNextFloppySector(Var Data):DWORD;override;

                        Function WriteNextFloppyTrack(Var Data):DWORD;override;
                        Function WriteNextFloppySector(Var Data):DWORD;override;
                                                                 

                        Function LockDrive(Drive:Byte):DWORD;override;
                        Function UnLockDrive(Drive:Byte):DWORD;override;
                        Function FormatTracks(Drive:Byte;var FormatParameters:T_FORMAT_PARAMETERS):DWORD;override;
                        Procedure SenseMediaType;override;
                      End;

implementation

type
  EInt13Error = class(Exception);


{ TInt13Handler }

Function TInt13Handler.ReadFloppySector(var Data; Drive, Side, Track,
  Sector: byte): DWORD;
begin
  if FDrive <> Drive then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
  inc(FCurrentSector);
  FillChar(Int13Reg,Sizeof(_DIOC_REGISTERS),0);
  with Int13Reg do
  Begin
    reg_EBX:=DWORD(@Data);
    reg_EAX:=MakeWord(1,2); // 2 = Sector Lezen
    reg_ECX:=MakeWord(Sector,Track);
    reg_EDX:=Makeword(Drive,Side);
    reg_Flags:=1;
  End;
  Interrupt13;
  if (Int13Reg.reg_Flags and 1 = 0) then Result:=0
   Else Result:=LoWord(Int13Reg.reg_EAX) shr 8;
end;

Function TInt13Handler.ReadFloppyTrack(var Data; Drive, Side,
  Track,SectorCount: byte): DWORD;
begin
  if FDrive <> Drive then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
  inc(FCurrentSector,SectorCount);
  FillChar(Int13Reg,Sizeof(_DIOC_REGISTERS),0);
  with Int13Reg do
  Begin
    reg_EBX:=DWORD(@Data);
    reg_EAX:=MakeWord(SectorCount,2); // 2 = Sector Lezen
    reg_ECX:=MakeWord(1,Track);
    reg_EDX:=Makeword(Drive,Side);
    reg_Flags:=1;
  End;
  Interrupt13;
  if (Int13Reg.reg_Flags and 1 = 0) then Result:=0
   Else Result:=LoWord(Int13Reg.reg_EAX) shr 8;
end;

Function TInt13Handler.ResetFloppydrive(Drive:Byte):DWORD;
Begin
  if FDrive <> Drive then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
  FillChar(Int13Reg,Sizeof(_DIOC_REGISTERS),0);
  with Int13Reg do
  Begin
    //reg_EAX:=MakeWord(0,0); is al 0
    reg_EDX:=Makeword(Drive,0);
    reg_Flags:=1;
  End;
  Interrupt13;
  if (Int13Reg.reg_Flags and 1 = 0) then Result:=0
   Else Result:=LoWord(Int13Reg.reg_EAX) shr 8;
end;

procedure TInt13Handler.Interrupt13;
Var Aantal:Dword;
begin
  if not FDiskOpen then
  begin
    FDrive_Handle:=CreateFile(VxD_Name,0,0,nil,0,FILE_FLAG_DELETE_ON_CLOSE,0);
    if  FDrive_Handle = INVALID_HANDLE_VALUE then
    Begin
      CloseHandle(FDrive_Handle);
      raise EInt13Error.Create('TInt13Handler Error no handle for Vxd ');
    end;
    FDiskOpen:=True;
  End;

  If Not DeviceIoControl(FDrive_Handle,VWIN32_DIOC_DOS_INT13,
                         @Int13Reg,Sizeof(_DIOC_REGISTERS),
                         @Int13Reg,Sizeof(_DIOC_REGISTERS),Aantal,nil) then
  Begin
    CloseHandle(FDrive_Handle);
    FDiskOpen:=False;
    raise EInt13Error.Create('TInt13Handler Error VWIN32_DIOC_DOS_INT13');
  End;
end;

Function TInt13Handler.WriteFloppySector(var Data; Drive, Side, Track,
  Sector: byte): DWORD;
begin
  if FDrive <> Drive then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
  FillChar(Int13Reg,Sizeof(_DIOC_REGISTERS),0);
  with Int13Reg do
  Begin
    reg_EBX:=DWORD(@Data);
    reg_EAX:=MakeWord(1,3); // 3 = Sector Schrijven
    reg_ECX:=MakeWord(Sector,Track);
    reg_EDX:=Makeword(Drive,Side);
    reg_Flags:=1;
  End;
  Interrupt13;
  if (Int13Reg.reg_Flags and 1 = 0) then Result:=0
   Else Result:=LoWord(Int13Reg.reg_EAX) shr 8;
end;

Function TInt13Handler.WriteFloppyTrack(var Data; Drive, Side, Track,
  SectorCount: byte): DWORD;
begin
  if FDrive <> Drive then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
  FillChar(Int13Reg,Sizeof(_DIOC_REGISTERS),0);
  with Int13Reg do
  Begin
    reg_EBX:=DWORD(@Data);
    reg_EAX:=MakeWord(SectorCount,3); // 3 = Sector Schrijven
    reg_ECX:=MakeWord(1,Track);
    reg_EDX:=Makeword(Drive,Side);
    reg_Flags:=1;
  End;
  Interrupt13;
  if (Int13Reg.reg_Flags and 1 = 0) then Result:=0
   Else Result:=LoWord(Int13Reg.reg_EAX) shr 8;
end;



function TInt13Handler.FormatFloppyTrack(Drive, Side, Track: byte): DWORD;
Var T:Integer;
    FormatTrack:TFormatTrack;
    //DriveParameters:TDriveParameters;
begin
  For T:=1 to 18 do
  Begin
    FormatTrack[T].TrackNumber:=Track;
    FormatTrack[T].HeadNumber:=Side;
    FormatTrack[T].SectorNumber:=T;
    FormatTrack[T].SectorSize:=2;
  End;

  FillChar(Int13Reg,Sizeof(_DIOC_REGISTERS),0);
  with Int13Reg do
  Begin
    reg_EBX:=DWORD(@FormatTrack);
    reg_EAX:=MakeWord(18,$05); // FormatTrack
    reg_ECX:=Makeword(0,Track);
    reg_EDX:=Makeword(Drive,Side);
    reg_Flags:=1;
  End;
  Interrupt13;
  if (Int13Reg.reg_Flags and 1 = 0) then Result:=0
   Else Result:=LoWord(Int13Reg.reg_EAX) shr 8;
end;

Function TInt13Handler.InitFormat(Drive:Byte):Dword;
Var DriveParameters:TDriveParameters;
begin
  FillChar(Int13Reg,Sizeof(_DIOC_REGISTERS),0);
  with Int13Reg do
  Begin
    reg_EDX:=Makeword(Drive,0);
    reg_Flags:=1;
  End;
  Interrupt13;

  FillChar(Int13Reg,Sizeof(_DIOC_REGISTERS),0);
  with Int13Reg do
  Begin
    reg_EBX:=DWORD(@DriveParameters);
    reg_EAX:=MakeWord(0,$18); // FormatTrack
    reg_ECX:=Makeword(18,79);
    reg_EDX:=Makeword(Drive,0);
    reg_Flags:=1;
  End;
  Interrupt13;
  if (Int13Reg.reg_Flags and 1 = 0) then Result:=0
  Else Result:=LoWord(Int13Reg.reg_EAX) shr 8;
End;

function TInt13Handler.ReadFloppy(var Data; Drive: Byte): DWORD;
begin
  result:=0;
end;

function TInt13Handler.WriteFloppy(var Data; Drive: Byte): DWORD;
begin
  result:=0;
end;

procedure TInt13Handler.CheckVersion;
var Os:TOSVersionInfo;
begin
  Os.dwOSVersionInfoSize:=SizeOf(TOSVersionInfo);
  if GetVersionEx(Os) then
  Begin
    Case Os.dwPlatformId of
    VER_PLATFORM_WIN32s:raise EInt13Error.Create('TInt13Handler Error Win32s is not supported');
    VER_PLATFORM_WIN32_NT:raise EInt13Error.Create('TInt13Handler Error NT is not supported');
    End;
  End else raise EInt13Error.Create('TInt13Handler Error GetVersionEx failed');
end;

function TInt13Handler.GetDiskGeometry2(var Geometry: T_DISK_GEOMETRY;
  Drive: Byte): DWORD;
begin
  result:=0;
end;


function TInt13Handler.CompileBootSector(Drive: Byte;var BootGeo: T_DISK_GEOMETRY): DWORD;
Var BootSec:TBootSector;
begin
  if ReadFloppySector(BootSec,Drive,0,0,1) = 0 then
  Begin
    with BootSec.BiosParameterBlock do
    Begin
      Case MediaType of
      $F0:BootGeo.MediaType:=F3_1Pt44_512;
      $F8:BootGeo.MediaType:=FixedMedia;
      $F9:if SectorsPerTrack = 15 then BootGeo.MediaType:=F5_1Pt2_512 else
                                       BootGeo.MediaType:=F3_720_512;
      $FA:BootGeo.MediaType:=Unknown;
      $FB:BootGeo.MediaType:=Unknown;
      $FC:BootGeo.MediaType:=F5_180_512;
      $FD:BootGeo.MediaType:=F5_360_512;
      $FE:BootGeo.MediaType:=F5_160_512;
      $FF:BootGeo.MediaType:=F5_320_512;
      else BootGeo.MediaType:=Unknown;
      end;
      if BootGeo.MediaType <> Unknown then
      Begin
        TULargeInteger(BootGeo.Cylinders).HighPart:=0;
        if SmallSectors <> 0 then
        BootGeo.Cylinders.LowPart:=(SmallSectors div SectorsPerTrack) div Heads else
          BootGeo.Cylinders.LowPart:=(LargeSectors div SectorsPerTrack) div Heads;
        BootGeo.TracksPerCylinder:=Heads;
        BootGeo.SectorsPerTrack:=SectorsPerTrack;
        BootGeo.BytesPerSector:=BytesPerSector;
        result:=0;
      End else result:=2;
    End;
  End else Result:=1;
End;




function TInt13Handler.GetDiskGeometry(var Geometry: T_DISK_GEOMETRY;
  Drive: Byte): DWORD;
Var BootGeo:T_DISK_GEOMETRY;
    Sec:array[0..1023] of byte;
Begin
  if FDrive <> Drive then
  Begin
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
    Geometry:=FDiskGeometry;
    result:=0;
    exit;
  end;

  if GetDriveType(Drive,Geometry) <> 0 then
  Begin
    Result:=1;
    exit;
  end;

  Case CompileBootSector(Drive,BootGeo) of
  0:Begin
      Geometry:=BootGeo;
      result:=0;
      exit;
    End;
  1:Begin
      Geometry.MediaType:=unknown;
      Result:=1;
      exit;
    end;
  2:MsgDlg('Boot = 2');
  End;

  if (Geometry.MediaType = F3_1Pt44_512) and
     (ReadFloppySector(Sec,Drive,0,0,10) <> 0) then
  Begin
    Geometry.MediaType:=F3_720_512;
    Geometry.Cylinders.HighPart:=0;
    Geometry.Cylinders.LowPart:=80;
    Geometry.TracksPerCylinder:=2;
    Geometry.SectorsPerTrack:=9;
    Geometry.BytesPerSector:=512;
    MsgDlg('patch1');
    Do720;
  End;
  result:=0;
End;



function TInt13Handler.NewDisk(Drive: Byte): DWORD;
begin
  FDrive:=Drive;
  if GetDiskGeometry(FDiskGeometry,Drive)<> 0 then
  Begin
    Result:=1;
    exit;
  end;
  FCurrentSector:=0;
  result:=0;
end;

function TInt13Handler.SeekLogicalSector(Drive: Byte;
  Sector: Dword): DWORD;
begin
  if FDrive <> Drive then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
  FCurrentSector:=Sector;
  Result:=0;
end;

function TInt13Handler.ReadNextFloppySector(var Data): DWORD;
var Side,Track,Sector:Byte;
begin
  Track:=FCurrentSector div (FDiskGeometry.TracksPerCylinder*FDiskGeometry.SectorsPerTrack);
  Sector:=FCurrentSector-(Track * FDiskGeometry.TracksPerCylinder*FDiskGeometry.SectorsPerTrack)+1;
  if Sector > FDiskGeometry.SectorsPerTrack then
  Begin
    Side:=1;
    Dec(Sector,FDiskGeometry.SectorsPerTrack);
  end else Side:=0;
  Result:=ReadFloppySector(Data,FDrive,Side,Track,Sector);
end;

function TInt13Handler.ReadNextFloppyTrack(var Data): DWORD;
var Side,Track:Byte;
begin
  Track:=FCurrentSector div (FDiskGeometry.TracksPerCylinder*FDiskGeometry.SectorsPerTrack);
  if FCurrentSector-
     (Track * FDiskGeometry.TracksPerCylinder*FDiskGeometry.SectorsPerTrack)+1 >
      FDiskGeometry.SectorsPerTrack then side:=1 else side:=0;
  Result:=ReadFloppyTrack(Data,FDrive,Side,Track,FDiskGeometry.SectorsPerTrack);
end;


{
mov ax, 440Dh        ; generic IOCTL
mov bh, LockLevel    ; see below
mov bl, DriveNum     ; see below
mov ch, 08h          ; device category (must be 08h)
mov cl, 4Bh          ; Lock Physical Volume
mov dx, Permissions  ; see below
int 21h

jc error
}


Function TInt13Handler.LockDrive(Drive: Byte): DWORD;
begin
  FillChar(Int13Reg,Sizeof(_DIOC_REGISTERS),0);
  with Int13Reg do
  Begin
    reg_EAX:=$440D;
    reg_EBX:=Makeword(Drive,0);
    reg_ECX:=Makeword($4B,$08);
    reg_EDX:=0;
    reg_Flags:=1;
  End;
  Interrupt21;
  if (Int13Reg.reg_Flags and 1 = 0) then Result:=0
  Else Result:=LoWord(Int13Reg.reg_EAX) shr 8;
end;

{
mov ax, 440Dh      ; generic IOCTLmov
bl, DriveNum   ; see below
mov ch, 08h        ; device category (must be 08h)
mov cl, 6Bh        ; Unlock Physical Volumeint 21hjc enter
}

function TInt13Handler.UnLockDrive(Drive: Byte): DWORD;
begin
  FillChar(Int13Reg,Sizeof(_DIOC_REGISTERS),0);
  with Int13Reg do
  Begin
    reg_EAX:=$440D;
    reg_EBX:=Makeword(Drive,0);
    reg_ECX:=Makeword($6B,$08);
    reg_Flags:=1;
  End;
  Interrupt21;
  if (Int13Reg.reg_Flags and 1 = 0) then Result:=0
  Else Result:=LoWord(Int13Reg.reg_EAX) shr 8;
end;

function TInt13Handler.WriteNextFloppySector(var Data): DWORD;
var Side,Track,Sector:Byte;
begin
  Track:=FCurrentSector div (FDiskGeometry.TracksPerCylinder*FDiskGeometry.SectorsPerTrack);
  Sector:=FCurrentSector-(Track * FDiskGeometry.TracksPerCylinder*FDiskGeometry.SectorsPerTrack)+1;
  if Sector > FDiskGeometry.SectorsPerTrack then
  Begin
    Side:=1;
    Dec(Sector,FDiskGeometry.SectorsPerTrack);
  end else Side:=0;
  Result:=WriteFloppySector(Data,FDrive,Side,Track,Sector);
end;

function TInt13Handler.WriteNextFloppyTrack(var Data): DWORD;
var Side,Track:Byte;
begin
  Track:=FCurrentSector div (FDiskGeometry.TracksPerCylinder*FDiskGeometry.SectorsPerTrack);
  if FCurrentSector-
     (Track * FDiskGeometry.TracksPerCylinder*FDiskGeometry.SectorsPerTrack)+1 >
      FDiskGeometry.SectorsPerTrack then side:=1 else side:=0;
  Result:=WriteFloppyTrack(Data,FDrive,Side,Track,FDiskGeometry.SectorsPerTrack);
end;

procedure TInt13Handler.Interrupt21;
Var Aantal:Dword;
begin
  if not FDiskOpen then
  begin
    FDrive_Handle:=CreateFile(VxD_Name,0,0,nil,0,FILE_FLAG_DELETE_ON_CLOSE,0);
    if  FDrive_Handle = INVALID_HANDLE_VALUE then
    Begin
      CloseHandle(FDrive_Handle);
      raise EInt13Error.Create('TInt13Handler Error no handle for Vxd ');
    end;
    FDiskOpen:=True;
  End;

  If Not DeviceIoControl(FDrive_Handle,VWIN32_DIOC_DOS_IOCTL,
                         @Int13Reg,Sizeof(_DIOC_REGISTERS),
                         @Int13Reg,Sizeof(_DIOC_REGISTERS),Aantal,nil) then
  Begin
    CloseHandle(FDrive_Handle);
    FDiskOpen:=False;
    raise EInt13Error.Create('TInt13Handler Error VWIN32_DIOC_DOS_IOCTL');
  End;
end;

function TInt13Handler.DiskSize(Drive: Byte): DWORD;
begin
  if (Not FDiskOpen) or (Drive <> FDrive) then
    if NewDisk(Drive) <> 0 then
    Begin
      result:=1;
      exit;
    end;
  with FDiskGeometry do
  Begin
    Result:=Cylinders.lowpart*TracksPerCylinder*SectorsPerTrack*BytesPerSector;
  End;
end;

function TInt13Handler.FormatTracks(Drive: Byte;
  var FormatParameters: T_FORMAT_PARAMETERS): DWORD;
begin
  result:=0;
end;

procedure TInt13Handler.ResetDrive(Drive: Byte);
begin
  FillChar(Int13Reg,Sizeof(_DIOC_REGISTERS),0);
  with Int13Reg do
  Begin
    reg_EDX:=Makeword(Drive,0);
    reg_Flags:=1;
  End;
  Interrupt13;
end;

function TInt13Handler.GetDriveType(Drive:Byte;var Geo:T_DISK_GEOMETRY):DWORD;
Var DPB:T_DOSDPB;
begin
  DPB.specialFunc:=1;
  FillChar(Int13Reg,Sizeof(_DIOC_REGISTERS),0);
  with Int13Reg do
  Begin
    reg_EBX:=Drive+1;
    reg_EAX:=$440D;
    reg_ECX:=$0860;
    reg_EDX:=DWORD(@DPB);
    reg_Flags:=1;
  End;
  Interrupt21;
  MsgDlg(DPB.bMedia);
  if (Int13Reg.reg_Flags and 1 = 0) then
  Begin
    Case DPB.devType of
    0:Geo.MediaType:=F5_360_512;
    1:Geo.MediaType:=F5_1Pt2_512;
    2:Geo.MediaType:=F3_720_512;
    5:Geo.MediaType:=FixedMedia;
    6:Geo.MediaType:=RemovableMedia;
    7:Geo.MediaType:=F3_1Pt44_512;
    8:Geo.MediaType:=RemovableMedia;
    9:Geo.MediaType:=F3_2Pt88_512;
    else Geo.MediaType:=unknown;
    end;
    if Geo.MediaType <> Unknown then
    Begin
      Result:=0;
      TULargeInteger(Geo.Cylinders).HighPart:=0;
      Geo.Cylinders.LowPart:=DPB.cCyl;
      Geo.TracksPerCylinder:=DPB.cHead;
      Geo.SectorsPerTrack:=DPB.SecPerTrack;
      Geo.BytesPerSector:=DPB.cbSec;
    end else Result:=2;
  end else Result:=1;
end;



procedure TInt13Handler.Do720;
Var c720_DPB:T_720_DPB;
    DOS_DPB:T_DOSDPB;T:Integer;
begin
  DOS_DPB.specialFunc:=0;
  FillChar(Int13Reg,Sizeof(_DIOC_REGISTERS),0);
  with Int13Reg do
  Begin
    reg_EBX:=1;
    reg_EAX:=$440D;
    reg_ECX:=$0860;
    reg_EDX:=DWORD(@DOS_DPB);
    reg_Flags:=1;
  End;
  Interrupt21;
  c720_DPB.DPB:=DOS_DPB;
  With c720_DPB.DPB do
  Begin
    cCyl:=80;
    MediaType:=0;
    cbSec:=512;
    secPerClus:=2;
    cSecRes:=1;    //Res
    cFat:=2;       //Number of Fats
    cDir:=112;       //Root entry s
    cSec:=1440;       //Number of sectors
    bMedia:=$F9;     //Media ID
    SecPerFat:=3;  //Sectors per fat
    SecPerTrack:=9;
    cHead:=2;
  End;
  c720_DPB.SecCount:=9;
  For T:=1 to 9 do
  Begin
    c720_DPB.Sectors[t].Number:=t;
    c720_DPB.Sectors[t].Size:=512;
  End;
  FillChar(Int13Reg,Sizeof(_DIOC_REGISTERS),0);
  with Int13Reg do
  Begin
    reg_EBX:=1;
    reg_EAX:=$440D;
    reg_ECX:=$0840;
    reg_EDX:=DWORD(@c720_DPB);
    reg_Flags:=1;
  End;
  Interrupt21;
  if (Int13Reg.reg_Flags and 1 = 0) then MsgDlg('Goed');
end;

procedure TInt13Handler.SenseMediaType;
var Par:T_Par;
begin
  MsgDlg('Hier');
  Par[0]:=0;
  Par[1]:=0;
  FillChar(Int13Reg,Sizeof(_DIOC_REGISTERS),0);
  with Int13Reg do
  Begin
    reg_EBX:=1;
    reg_EAX:=$440D;
    reg_ECX:=$4868;
    reg_EDX:=DWORD(@Par);
    reg_Flags:=1;
  End;
  Interrupt21;
  if (Int13Reg.reg_Flags and 1 = 0) then MsgDlg('Goed '+IntToStr(Par[1])) else
  MsgDlg('Fout '+IntToStr(Int13Reg.reg_EAX));
end;

end.



